module Parakeet
  module Guideline

    # This will be included in a Guideline class that the user will
    # generate and define the parameters/vallidations.
    # class Guideline
    #   include Parakeet::Guideline
    #   def initialize
    #     verify_params('user#create', 'first_name', :string, { exists: true, length: 'under 10' })
    #   end
    # end

    # This seems like a super duplicative way to do this.
    # Can pass in object that contains controller/action and ActionController
    # and all parameters/types/validations instead. Is that just as messy?
    # TODO: Update with a DRYer solution considering multiple parameters for a
    # controller action
    def verify_params(controller_action, parameter, type, validations)
      # TODO: I'm thinking that this should create an object that represents
      # an action. Then into that object insert the individual parameter rules.
      # controller_actions[controller_action] = [] if controller_actions[controller_action].nil?
      controller_actions[controller_action] << Parameter.new(parameter, type, validations)
    end

    def controller_actions
      @controller_actions ||= Hash.new{ |hash, key| hash[key] = [] }
    end
  end
end
